unit UList;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,UMyPoint;
type
  Tpointlist=class(Tlist)
    procedure add(Apoint:TMypoint);//   
    procedure delete(index:integer);
    function GetPoint(index:integer):TMypoint;
    procedure SetPoint(index:integer;Apoint:TMypoint);
    function IndexPoint(x,y:integer):integer;
    function cross(Ax,Ay:integer):boolean;
    function quant:integer;
    function getchoosen:integer;

    property points[index:integer]:TMypoint read GetPoint write SetPoint;

  end;

implementation
///////
procedure Tpointlist.add(Apoint:TMypoint);
begin
  inherited add(apoint);
end;
////////
procedure Tpointlist.delete(index: integer);
begin
  points[index].Destroy;
  inherited Delete(index);
end;
///////
function Tpointlist.GetPoint(index:integer):TMypoint;
begin
  result:=inherited Items[index];
end;
///////
procedure Tpointlist.SetPoint(index:integer;Apoint:TMypoint);
begin
  inherited Items[index]:=Apoint;
end;
///////
function TPointList.IndexPoint(x, y: integer): integer;
var i:integer;
    ok:boolean;
begin
  i:=0;ok:=false;
  while not ok and(i<>count) do
  begin
    ok:=(points[i].has_point(x,y)) ;
    inc(i);
  end;

  if ok then result:=i-1
  else result:=-1;
end;
/////////
function Tpointlist.cross(Ax, Ay: integer): boolean;
var ok:boolean;
    i:integer;
begin
  ok:=false;i:=0;
  while not ok and (i<>count) do
    begin
      ok:=points[i].has_point(Ax,Ay);
      inc(i);
    end;
  result:= ok;
end;
////////
function Tpointlist.quant: integer;
var i:integer;
begin
  result:=0;i:=0;
  while (i<>count) and (result<>2) do
    begin
      if points[i].chosen then inc(result);
      inc(i);
    end;
end;
/////////
function Tpointlist.getchoosen: integer;
var i:integer;
begin
  i:=0;result:=-1;
  while (i<>count)and (result=-1)do
    begin
      if points[i].chosen then result:=i;
      inc(i);
    end;
end;

end.
