unit UMyPoint;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;
const r=15;
      bgrd=ClWhite-10;
type
  TMyPoint = class
  private
    Fx,Fy:integer;
    Fcanvas:Tcanvas;
    choose:boolean;
  public
    constructor create(Ax,Ay:integer;Acanvas:Tcanvas);
    procedure set_ch(ch:boolean);
    procedure draw(i:integer;acolor:TColor=clBlack);//0-hide,1-show,2-active
    function has_point(ax,ay:integer):boolean;
    property gx:integer read Fx ;
    property gy:integer read Fy ;
    property chosen:boolean read choose write Set_ch;
  end;
implementation
//////// 
constructor  TMypoint.create(Ax,Ay:integer;Acanvas:Tcanvas);
begin
  Fx:=Ax;
  Fy:=Ay;
  Fcanvas:=Acanvas;
  choose:=false;
end;
///////     
procedure TMypoint.draw(i:integer;acolor:TColor=clBlack);
begin
  if i=1 then
    begin
      Fcanvas.Brush.Color:=acolor;
      Fcanvas.Pen.Color:=Clblack;
      Fcanvas.Ellipse(Fx-r,Fy-r,Fx+r,Fy+r);
    end;
  if i=0 then
    begin
      Fcanvas.Brush.Color:=bgrd;
      Fcanvas.Pen.Color:=bgrd;
      Fcanvas.Ellipse(Fx-r,Fy-r,Fx+r,Fy+r);
    end;
  if i=2 then
    begin
      Fcanvas.Brush.Color:=clBlack;
      Fcanvas.Pen.Color:=clRed;
      Fcanvas.Ellipse(Fx-r,Fy-r,Fx+r,Fy+r);
    end;
end;
////////      
function TMypoint.has_point(ax,ay:integer):boolean;
begin
  result:=((ax>=(Fx-2*r))and(ax<=(Fx+2*r))and(ay>=(Fy-2*r))and(ay<=(Fy+2*r)));
end;
//////   
procedure TMyPoint.set_ch(ch: boolean);
begin
  choose:=ch;
end;

end.
